<?php
namespace PME\Modules\Planejamento\Cadastro;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class CentralReportController extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $utilities;

    public function __construct(ReportService $reportService, $birtStrategy, $utilities) {
      $this->birtStrategy  = $birtStrategy;
      $this->utilities   = $utilities;

      parent::__construct($reportService);
    }

	protected $reportMapping = array (
      'GER96000' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "CENTRAIS"        => "P_CDFILIAL",
              "NRORG"           => "P_NRORG",
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->utilities->getNrOrg();
      
      if (empty($row['CENTRAIS'])) $row['CENTRAIS'] = 'T';
      else {
         $centraisConcatenadas = '_';
         foreach($row['CENTRAIS'] as $central){
             $centraisConcatenadas .= $central.'_';
         }
         $row['CENTRAIS'] = $centraisConcatenadas;
      }
      
      $row['NRORG'] = $nrorg;
      
      $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}